//Programa: Teste de Display LCD 16 x 2
//Autor: FILIPEFLOP
 
//Carrega a biblioteca LiquidCrystal
#include <LiquidCrystal.h>
 
//Define os pinos que serão utilizados para ligação ao display
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

int photoRPin = 0; 
int minLight;          //Used to calibrate the readings
int maxLight;          //Used to calibrate the readings
int lightLevel;
float adjustedLightLevel;
float alpha = 0.9;

void setup()
{
  //Setup the starting light level limits
  lightLevel=analogRead(photoRPin);
  minLight=lightLevel-20;
  maxLight=lightLevel;
 
  //Define o número de colunas e linhas do LCD
  lcd.begin(16, 2);

}
 
void loop()
{
  //auto-adjust the minimum and maximum limits in real time
  lightLevel=analogRead(photoRPin);
  if(minLight>lightLevel){
    minLight=lightLevel;
  }
  if(maxLight<lightLevel){
    maxLight=lightLevel;
  }
 
  //Adjust the light level to produce a result between 0 and 100.
  adjustedLightLevel = adjustedLightLevel*alpha + map(lightLevel, minLight, maxLight, 0, 100)*(1-alpha);
  

  //Limpa a tela
  lcd.clear();
  //Posiciona o cursor na coluna 3, linha 0;
  lcd.setCursor(1, 0);
  //Envia o texto entre aspas para o LCD
  lcd.print("Level: ");
  lcd.print(adjustedLightLevel);
  lcd.print("%");
  delay(100); 
}
